package com.landray.kmss.qw.message.util;

import com.alibaba.fastjson.JSONObject;
import com.landray.kmss.qw.message.model.QwMessageMain;
import com.landray.kmss.third.weixin.work.api.WxworkApiService;
import com.landray.kmss.third.weixin.work.model.WeixinWorkConfig;
import com.landray.kmss.third.weixin.work.util.WxworkUtils;
import com.landray.kmss.util.ResourceUtil;
import com.landray.kmss.util.SecureUtil;
import com.landray.kmss.util.StringUtil;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Function;
import java.util.function.Predicate;

public class SendUtil {

   static String PURL = "/third/weixin/work/sso/pc_message.jsp?oauth=";


   private static String getDomainUrl(String fdId) {
      String purl = PURL + "wx2ekp";
      String domainName = WeixinWorkConfig.newInstance().getWxDomain();
      if(StringUtil.isNull(domainName)) {
         domainName = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
      }

      if(domainName.endsWith("/")) {
         domainName = domainName.substring(0, domainName.length() - 1);
      }

      purl = domainName + purl + "&url=" + SecureUtil.BASE64Encoder(domainName + "/qw/message/qw_message_main/qwMessageMain.do?method=view&fdId=" + fdId);
      return purl;
   }

   private static JSONObject buildParam(QwMessageMain main, String userIds, Integer level) {
      String purl = getDomainUrl(main.getFdId());
      String docSubject = main.getDocSubject();
      if(level == null) {
         level = Integer.valueOf(3);
      }

      switch(level.intValue()) {
      case 1:
         docSubject = ResourceUtil.getString("enums.notify.level.1", "third-weixin") + docSubject;
         break;
      case 2:
         docSubject = ResourceUtil.getString("enums.notify.level.2", "third-weixin") + docSubject;
      }

      String description = "标题：" + docSubject + "\r\n内容：" + main.getFdText();
      JSONObject paramObj = new JSONObject();
      JSONObject textcard = new JSONObject();
      textcard.put("title", main.getFdSystem().getFdName());
      textcard.put("description", description);
      textcard.put("url", purl);
      textcard.put("btntxt", "详情");
      paramObj.put("touser", userIds);
      paramObj.put("msgtype", "textcard");
      paramObj.put("textcard", textcard);
      paramObj.put("agentid", WeixinWorkConfig.newInstance().getWxAgentid());
      System.out.println("paramObj:" + paramObj.toJSONString());
      return paramObj;
   }

   public static JSONObject send(QwMessageMain main, String userIds, String agentid, Integer level) throws Exception {
      JSONObject result = null;
      JSONObject paramObj = buildParam(main, userIds, level);
      WxworkApiService wxworkApiService = WxworkUtils.getWxworkApiService();
      result = wxworkApiService.messageSend(agentid, paramObj, WeixinWorkConfig.newInstance().getWxCorpid());
      return result;
   }

   public static Predicate distinctByKey(Function keyExtractor) {
      ConcurrentHashMap seen = new ConcurrentHashMap();
      return (param3) -> {
         return seen.putIfAbsent(keyExtractor.apply(t), Boolean.TRUE) == null;
      };
   }

}
